#include <stdio.h>
#include "vec.hxx"

void test1()
{
    Vec<int> v(1,1);
    printf("%d\n", sizeof(v));
    v[3] = 33;
    printf("%d\n", v[3]);

    printf("empty = %d\n", v.empty());

    v.push_back( 555 );
    printf("size = %d\n", v.size());

    printf("empty = %d\n", v.empty());

    v.push_back( 777 );
    printf("size = %d\n", v.size());

    v.push_back( 999 );
    printf("size = %d\n", v.size());

    printf("back = %d\n", v.back());

    Vec<int>::iterator it;
    int i;
    for (i = 0, it = v.begin(); it != v.end(); i++, it++) {
        int x = *it;
        printf("%d, *it = %d\n", i, x);
    }
}

class SampleClass
{
public:

    int   a;
    const char* s;

    SampleClass()
        : a(0), s(NULL) {}

    SampleClass( int _a, const char * _s )
        : a(_a), s(_s) {}

    SampleClass( const SampleClass& r )
        : a(r.a), s(r.s) {}
};

void test2()
{
    Vec< SampleClass > a(3,2);
    a[5] = SampleClass( 111, "abc" );

    printf("%d, %s\n", a[5].a, a[5].s);

    Vec< SampleClass >* p = &a;

    printf("%d, %s\n", (*p)[5].a, (*p)[5].s);

    p->push_back( SampleClass( 222, "xyz" ) );
    printf("size = %d\n", p->size());

    Vec< SampleClass >::iterator it;
}

typedef Vec< SampleClass > SampleClassVector;

class XXX
{
public:
    SampleClassVector  mnSampleClassVector;

    XXX();
};   

XXX::XXX()
    : mnSampleClassVector( 5, 3 )
{
}


void test3()
{
    XXX x;
}

main()
{
    test1();
    test2();
}
